class HashST {
	static int hash(String s, int M) {
    	int h = 0, a = 31415, b = 27183;
    		for (int i = 0; i < s.length(); i++) {
        		h = (a*h + s.charAt(i)) % M;
        		a = a*b % (M-1); 
      		}
    		return h;
  	}
	// innere Klasse Node für einfach verkettete Liste
    	private class Node {
        	ITEM item;
        	Node next;
        	Node(ITEM x, Node t) {
                	item = x;
                	next = t;
        	}
		public String toString() {
			if (next != null) 
				return item + "-" + next ;
			else
				return item + "";
		}
      	}
	private Node[] heads;
	private int N, M;
	HashST(int maxN) {
		N = 0;
		M = maxN/5;
		heads = new Node[M];
	}
	// Suchen von Elementen durch sequentielles Durchlaufen
    	private ITEM searchR(Node t, KEY key) {
        	if (t == null)
               	 	return null;
        	if (t.item.key().equals( key ))
                	return t.item;
        	return searchR(t.next, key);
    	}
	ITEM search(KEY key) {
		return searchR(heads[hash(key.toString(), M)], key);
	}
	void insert(ITEM x) {
		int i = hash(x.key().toString(), M);
    		heads[i] = new Node(x, heads[i]); N++;
	}
	public void print() {
		int i;
		for ( i = 0; i < M; i++ )
			if (heads[i] != null)
				Out.println( "[" + i + "]" + heads[i] );
			else
				Out.println( "[" + i + "]" );
	}

	public static void main(String [] args) {
		HashST table = new HashST( 50 );
		int numElem = 10;
		int i;

		try {
			numElem = Integer.parseInt(args[0]);
		} catch (Exception e) {}

		Out.println("Generating " + numElem + " elements");
		for (i = 0; i < numElem; i++ ) {
			stringItem s = new stringItem();
			s.rand();
			table.insert( s );
		}
		table.print();
	}
}
