// Codefragment
// Einfügen in Rot-Schwarz-baum


class RSTree {
	// innere Klasse Node für einfach verkettete Liste
    	static class Node {
        	ITEM item;
		boolean cbit;
        	Node r, l;

        	Node(ITEM x, boolean c) {
                	item = x;
                	cbit = c;
        	}
        }

	private static final boolean R = true;
	private static final boolean B = false;

	private Node head;
	private boolean red(Node x) {
		if (x == null) return false; return x.cbit;
	}
	private Node rotR(Node h) {
		Node x = h.l; h.l = x.r; x.r = h; return x;
	}
	private Node rotL(Node h) {
		Node x = h.r; h.r = x.l; x.l = h; return x;
	}
	private Node insertR(Node h, ITEM x, boolean sw) { 
    		if (h == null) { return new Node(x, R); }
    		if (red(h.l) && red(h.r)) {
			 h.cbit = R; h.l.cbit = B; h.r.cbit = B;
		}
    		if (x.key().less( h.item.key())) { 
        		h.l = insertR(h.l, x, false); 
        		if (red(h) && red(h.l) && sw) h = rotR(h); 
        		if (red(h.l) && red(h.l.l)) {
				h = rotR(h);
				h.cbit = B;
				h.r.cbit = R;
			}
      		} else { 
        		h.r = insertR(h.r, x, true); 
        		if (red(h) && red(h.r) && !sw) h = rotL(h); 
        		if (red(h.r) && red(h.r.r)) {
				h = rotL(h); h.cbit = B; h.l.cbit = R;
			}
      		}
    		return h;
  	}
	void insert(ITEM x) {
		head = insertR(head, x, B); head.cbit = B;
	}
}
