// Arraybasierte Symboltabelle
// Schlüssel müssen Operationen less(9 und qeuals() unterstützen

class ST_KEY
  {
    private boolean less(KEY v, KEY w)
      { return v.less(w); }
    private boolean equals(KEY v, KEY w)
      { return v.equals(w); }
    private ITEM[] st;
    private int N = 0;
    ST_KEY(int maxN)
      { st = new ITEM[maxN]; }
    int count()
      { return N; }
    void insert(ITEM x)
      { int i = N++; KEY v = x.key();
        while (i > 0 && less(v, st[i-1].key()))
          { st[i] = st[i-1]; i--; }
        st[i] = x;
      }
    ITEM search(KEY key)
      { int i = 0;
        for ( ; i < N; i++)
          if (!less(st[i].key(), key)) break;
        if (i == N) return null;
        if (equals(key, st[i].key())) return st[i];
        return null;
      }
    ITEM select(int k)
      { return st[k]; }
  }

