// Symboltabelle auf Basis einer verketteten Liste

class ST_LIST {
    // innere Klasse Node für einfach verkettete Liste
    private class Node {
	ITEM item;
	Node next;
        Node(ITEM x, Node t) {
		item = x;
		next = t;
	}
      }
    private Node head;
    private int N;

    ST_LIST(int maxN) {
	head = null;
	N = 0;
    }
    int count() {
	return N;
    }
    void insert(ITEM x) {
	head = new Node(x, head);
	N++;
    }
    // Suchen von Elementen durch sequentielles Durchlaufen
    private ITEM searchR(Node t, KEY key) { 
        if (t == null)
		return null;
        if (t.item.key().equals( key ))
          	return t.item;
        return searchR(t.next, key);
    }
    ITEM search(KEY key) {
	return searchR(head, key);
    }
    public String toString() {
	Node h = head;
	String s = "";
        while (h != null) {
		s += h.item + "\n";
		h = h.next;
	}
        return s;
    }
}

