// schlüsselindizierte, arraybasierte Symboltabelle
// Schlüssel sind positive Ganzzahlen; kleiner als Parameter beim Konstruktor


class ST {
    private intkeyItem[] st;
    ST(int M)
      { st = new intkeyItem[M]; }
    int count()
      { int N = 0;
        for (int i = 0; i < st.length; i++)
          if (st[i] != null) N++;
        return N; 
      }
    void insert(intkeyItem x)
      { st[x.key()] = x; }
    void remove(int key) 
      { st[key] = null; }
    intkeyItem search(int key)
      { return st[key]; }
    intkeyItem select(int k)
      { 
        for (int i = 0; i < st.length; i++)
          if (st[i] != null && k-- == 0) 
            return st[i];
        return null; 
      }
    public String toString()
      { String s = "";
        for (int i = 0; i < st.length; i++)
          if (st[i] != null) s += st[i] + "\n";
        return s;
      }
}
