// Symboltabelle basierend auf binärem Suchbaum

class ST_BST {
    private class Node
      { ITEM item; Node l, r;
        Node(ITEM x) { item = x; }
      }
    private Node head;
    ST_BST(int maxN)
      { head = null; }
    private Node insertR(Node h, ITEM x)
      {
        if (h == null) 
            return new Node(x);
        if (x.key().less( h.item.key())) 
             h.l = insertR(h.l, x);                
        else h.r = insertR(h.r, x);
        return h;
      }
    void insert(ITEM x)
      { head = insertR(head, x); }
    private ITEM searchR(Node h, KEY v)
      { 
        if (h == null) return null;
        if (h.item.key().equals(v)) return h.item;
        if (v.less( h.item.key())) 
             return searchR(h.l, v);                
        else return searchR(h.r, v);
      }
    ITEM search(KEY key)
      { return searchR(head, key); }
}
